{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit KOLUnit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF (place your units here->)}, DecimalCalculations;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TForm1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Edit1: TKOLEditBox;
    Edit2: TKOLEditBox;
    Panel1: TKOLPanel;
    bAdd: TKOLButton;
    bSub: TKOLButton;
    bMul: TKOLButton;
    bDiv: TKOLButton;
    Edit3: TKOLEditBox;
    bRoot: TKOLButton;
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure bAddClick(Sender: PObj);
    procedure bSubClick(Sender: PObj);
    procedure bMulClick(Sender: PObj);
    procedure bDivClick(Sender: PObj);
    procedure bRootClick(Sender: PObj);
    procedure Edit1KeyChar(Sender: PControl; var Key: KOLChar;
      Shift: Cardinal);
  private
    procedure SetEdit3(const Value: TDecimal);
    { Private declarations }
  public
    { Public declarations }
    function X: TDecimal;
    function Y: TDecimal;
    property Z: TDecimal write SetEdit3;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I KOLUnit1_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  bRoot.Caption := #$D6;
end;

procedure TForm1.bAddClick(Sender: PObj);
begin
  Z := DecimalAdd( X, Y );
end;

procedure TForm1.SetEdit3(const Value: TDecimal);
begin
  Edit3.Text := Decimal2Str( Value );
end;

function TForm1.X: TDecimal;
begin
  Result := Str2Decimal( Edit1.Text );
end;

function TForm1.Y: TDecimal;
begin
  Result := Str2Decimal( Edit2.Text );
end;

procedure TForm1.bSubClick(Sender: PObj);
begin
  Z := DecimalSub( X, Y );
end;

procedure TForm1.bMulClick(Sender: PObj);
begin
  Z := DecimalMul( X, Y );
end;

procedure TForm1.bDivClick(Sender: PObj);
begin
  TRY
  Z := DecimalDiv( X, Y );
  EXCEPT
  //
  END;
end;

procedure TForm1.bRootClick(Sender: PObj);
begin
  Z := DecimalRoot( X );
end;

procedure TForm1.Edit1KeyChar(Sender: PControl; var Key: KOLChar;
  Shift: Cardinal);
begin
  CASE Key OF
  '0'..'9',#8: ;
  ',': Key := '.';
  else
    CASE Key OF
    '+': bAddClick( nil );
    '-': bSubClick( nil );
    '*': bMulClick( nil );
    '/': bDivClick( nil );
    END;
    Key := #0;
  END;
end;

end.


